
#define FN 0x80
#define FV 0x40
#define FB 0x10
#define FD 0x08
#define FI 0x04
#define FZ 0x02
#define FC 0x01
/*
#define MEM(address)														\
(																			\
	(is_switched && (address)>=0x8000)?										\
		(is_FDS && (address)>=0x6000 && (address)<0x8000)?					\
			bdata[4096*c_bank[(address)>>12]+((address)&0xFFF)]:			\
			bdata[4096*c_bank[((address)&0x7000)>>12]+((address)&0xFFF)]:	\
			data[address]													\
)*/

#define MEM(address) (data[(address)])
#define ZPMEM(address) (data[(address)&0xFF])
#define STACK(address) (data[address])
//#define MEM(address) (data[address])
#define LO() (MEM(pc))
#define HI() (MEM(pc+1))
//#define FETCH() (MEM(pc++))
#define SETPC(newpc) (pc = (newpc))
#define PUSH(data) (STACK(0x100 + (sp--)) = (data))
#define POP() (STACK(0x100 + (++sp)))

#define IMMEDIATE() (LO())
#define ABSOLUTE() (LO() | (HI() << 8))
#define ABSOLUTEX() (((LO() | (HI() << 8)) + x) & 0xffff)
#define ABSOLUTEY() (((LO() | (HI() << 8)) + y) & 0xffff)
#define ZEROPAGE() (LO() & 0xff)
#define ZEROPAGEX() ((LO() + x) & 0xff)
#define ZEROPAGEY() ((LO() + y) & 0xff)
#define INDIRECTX() (MEM((LO() + x) & (0xff)) | (MEM((LO() + x + 1) & (0xff)) << 8))
#define INDIRECTY() (((MEM(LO()) | (MEM((LO() + 1) & 0xff) << 8)) + y) & 0xffff)
//#define INDIRECTY() (data[(data[IMM8()]+256*data[IMM8()+1]+y)&0xFFFF])

#define IMM8() (MEM(pc))
#define ABS16() (MEM(MEM(pc)+256*MEM(pc+1)))
#define ABS16X() (MEM((MEM(pc)+256*MEM(pc+1)+x)&0xFFFF))
#define ABS16Y() (MEM((MEM(pc)+256*MEM(pc+1)+y)&0xFFFF))
#define ABSZP() (ZPMEM(MEM(pc)))
#define ABSZPX() (ZPMEM(MEM(pc)+x))
#define ABSZPY() (ZPMEM(MEM(pc)+y))
#define INDX()	(MEM(ZPMEM(MEM(pc)+x)+256*ZPMEM(MEM(pc)+x+1)))
#define INDY()	(MEM((ZPMEM(MEM(pc))+256*ZPMEM(MEM(pc)+1)+y)&0xFFFF))

#define IMM16() (MEM(pc)+256*MEM(pc+1))
#define IMM16X() ((MEM(pc)+256*MEM(pc+1)+x)&0xFFFF)
#define IMM16Y() ((MEM(pc)+256*MEM(pc+1)+y)&0xFFFF)
#define IMM8X() ((MEM(pc)+x)&0xFF)
#define IMM8Y() ((MEM(pc)+y)&0xFF)
#define IDDRX() (ZPMEM(MEM(pc)+x)+256*ZPMEM(MEM(pc)+x+1))
#define IDDRY() ((ZPMEM(MEM(pc))+256*ZPMEM(MEM(pc)+1)+y)&0xFFFF)

#define BANKSWITCH(bank,val)													\
{																				\
	if(c_bank[bank]!=(val) && (val)!=-1){										\
		/*printf("Bank %i switch! Old: %i New: %i\n",bank,c_bank[bank],(val));*/	\
		/*memcpy(&bdata[4096*c_bank[bank]],&data[0x8000+4096*(bank)],0x1000);*/	\
		/*printf("Pass 1\n");*/														\
		memcpy(&data[0x8000+4096*(bank)],&bdata[4096*(val)],0x1000);			\
		/*printf("Pass 2\n");*/														\
		c_bank[bank]=(val);														\
	}																			\
}

#define FDS_BSWITCH(bank,val)												\
{																				\
	if(c_bank[bank&7]!=(val) && (val)!=-1){									\
		/*printf("FDS Bank %i switch! Old: %i New: %i\n",bank,c_bank[bank&7],(val));*/	\
		memcpy(&data[4096*(bank&7)],&bdata[4096*(val)],0x1000);					\
		memcpy(&data[0x8000+4096*(bank&7)],&bdata[4096*(val)],0x1000);			\
		c_bank[bank&7]=(val);														\
		data[0x5FF0+(bank&7)]=val;													\
		data[0x5FF8+(bank&7)]=val;													\
	}																			\
}

#define WRITE_4015(value)				\
{										\
	if(value&0x10)						\
		dpcm_triggered=1;				\
										\
}

#define WRITE_N163_DATA(value)									\
{																\
	if(n163_addr&0x40){											\
		temp8a=(n163_addr&0x38)>>3;								\
		switch(n163_addr&7){									\
			case 0:												\
				N163[temp8a].freq&=0x3FF00;						\
				N163[temp8a].freq|=value;						\
				break;											\
			case 2:												\
				N163[temp8a].freq&=0x300FF;						\
				N163[temp8a].freq|=256*value;					\
				break;											\
			case 4:												\
				N163[temp8a].freq&=0x0FFFF;						\
				N163[temp8a].freq|=65536*(value&3);				\
				N163[temp8a].w_length=value>>2;					\
				break;											\
			case 6:												\
				N163[temp8a].w_addr=value;						\
				break;											\
			case 7:												\
				N163[temp8a].vol=value&0xF;						\
				if(temp8a==7) n163_ch=value>>4;					\
				break;											\
			default: break;										\
		}														\
	} else {													\
		n163_wram[n163_addr&0x3F]=value;						\
	}															\
	/*if((n163_addr & 0x7) == 4) printf("N163 WRITE: $%02X @ $%02X\n", value, n163_addr);*/\
																\
	if(n163_addr&0x80) {n163_addr++; n163_addr |= 0x80;}		\
}

#define WRITE_N163_ADDR(value)									\
{																\
	n163_addr=value;											\
	/*printf("N163 ADDR: 0x%02X\n",value);*/					\
}

#define WRITE_VRC7_DATA(value)									\
{																\
	if(vrc7_addr>=0x10 && vrc7_addr<0x40){						\
		temp8a=vrc7_addr&0x7;									\
		switch(vrc7_addr>>4){									\
			case 1:												\
				vrc7_regs[temp8a][0]=value;						\
				break;											\
			case 2:												\
				vrc7_regs[temp8a][1]=value;						\
				break;											\
			case 3:												\
				vrc7_regs[temp8a][2]=value;						\
				break;											\
			default: break;										\
		}														\
	} else if(vrc7_addr<8) {									\
		vrc7_custom[vrc7_addr]=value;							\
	}															\
}

#define WRITE_VRC7_ADDR(value)									\
{																\
	vrc7_addr=value;											\
	/*printf("VRC7 ADDR: 0x%02X\n",value);*/					\
}

#define WRITE_S5B_DATA(value)									\
{																\
	s5b_regs[s5b_addr]=value;									\
																\
}

#define WRITE_S5B_ADDR(value)									\
{																\
	s5b_addr=value&15;											\
	/*printf("VRC7 ADDR: 0x%02X\n",value);*/					\
}


#define WRITE(address,value)										\
{																	\
	temp16=address;													\
	temp8=value;													\
	/*cpuwritemap[(address)>>6]=1; */								\
	if(is_switched){												\
		switch(temp16){												\
			case 0x5FF6: if(is_FDS) {FDS_BSWITCH(6,(temp8));} break;	\
			case 0x5FF7: if(is_FDS) {FDS_BSWITCH(7,(temp8));} break;	\
			case 0x5FF8: /*if(!is_FDS)*/ BANKSWITCH(0,temp8); break;	\
			case 0x5FF9: /*if(!is_FDS)*/ BANKSWITCH(1,temp8); break;	\
			case 0x5FFA: /*if(!is_FDS)*/ BANKSWITCH(2,temp8); break;	\
			case 0x5FFB: /*if(!is_FDS)*/ BANKSWITCH(3,temp8); break;	\
			case 0x5FFC: /*if(!is_FDS)*/ BANKSWITCH(4,temp8); break;	\
			case 0x5FFD: /*if(!is_FDS)*/ BANKSWITCH(5,temp8); break;	\
			case 0x5FFE:											\
				if(!is_FDS) BANKSWITCH(6,temp8);					\
				if(is_FDS) FDS_BSWITCH(14,(temp8));					\
				break;												\
			case 0x5FFF:											\
				if(!is_FDS) BANKSWITCH(7,temp8)						\
				if(is_FDS) {FDS_BSWITCH(15,(temp8));}				\
				break;												\
			default: break;											\
		}															\
	}																\
	if(temp16==0x4015)												\
		WRITE_4015(temp8);											\
	if(temp16>=0x4800 && temp16<0x5000)								\
		WRITE_N163_DATA(temp8);										\
	if(temp16>=0x8000){												\
		switch(temp16){												\
			case 0x9010: WRITE_VRC7_ADDR(temp8); break;				\
			case 0x9030: WRITE_VRC7_DATA(temp8); break;				\
			case 0x9000: vrc6_vol[0]=temp8; break;					\
			case 0x9001:											\
				vrc6_freq[0]&=0x8F00;								\
				vrc6_freq[0]|=temp8;								\
				break;												\
			case 0x9002:											\
				vrc6_freq[0]&=0xFF;									\
				vrc6_freq[0]|=256*temp8;							\
				break;												\
			case 0xA000: vrc6_vol[1]=temp8; break;					\
			case 0xA001:											\
				vrc6_freq[1]&=0x8F00;								\
				vrc6_freq[1]|=temp8;								\
				break;												\
			case 0xA002:											\
				vrc6_freq[1]&=0xFF;									\
				vrc6_freq[1]|=256*temp8;							\
				break;												\
			case 0xB000: vrc6_vol[2]=temp8; break;					\
			case 0xB001:											\
				vrc6_freq[2]&=0x8F00;								\
				vrc6_freq[2]|=temp8;								\
				break;												\
			case 0xB002:											\
				vrc6_freq[2]&=0xFF;									\
				vrc6_freq[2]|=256*temp8;							\
				break;												\
			default: break;											\
		}															\
		if(temp16>=0xF800)											\
			WRITE_N163_ADDR(temp8);									\
		if(temp16>=0xC000 && temp16<0xE000)							\
			WRITE_S5B_ADDR(temp8);									\
		if(temp16>=0xE000)											\
			WRITE_S5B_DATA(temp8);									\
		if(is_FDS) data[temp16]=temp8;								\
	} else {														\
		data[temp16]=temp8;											\
	}																\
}

#define BRANCH()                        \
{                                       \
  temp = MEM(pc);                       \
  pc++;									\
  if (temp < 0x80)                      \
    SETPC(pc + temp);                   \
  else                                  \
    SETPC(pc + temp - 0x100);           \
}

#define SETFLAGS(data)                  \
{                                       \
  if (!(data))                          \
    flags = (flags & ~FN) | FZ;         \
  else                                  \
    flags = (flags & ~(FN|FZ)) |        \
    ((data) & FN);                      \
}

#define READ(addr)						\
{										\
	if((addr) >= 0x4800 && (addr) < 0x5000 && (n163_addr&0x80)) {n163_addr++; n163_addr |= 0x80;} \
										\
}

#define ASSIGNSETFLAGS(dest, data)      \
{                                       \
  dest = data;                          \
										\
										\
  if (!dest)                            \
    flags = (flags & ~FN) | FZ;         \
  else                                  \
    flags = (flags & ~(FN|FZ)) |        \
    (dest & FN);                        \
}

#define ADC(data)                                                        \
{                                                                        \
    unsigned tempval = data;                                             \
                                                                         \
    if (flags & FD)                                                      \
    {                                                                    \
        temp = (a & 0xf) + (tempval & 0xf) + (flags & FC);               \
        if (temp > 0x9)                                                  \
            temp += 0x6;                                                 \
        if (temp <= 0x0f)                                                \
            temp = (temp & 0xf) + (a & 0xf0) + (tempval & 0xf0);         \
        else                                                             \
            temp = (temp & 0xf) + (a & 0xf0) + (tempval & 0xf0) + 0x10;  \
        if (!((a + tempval + (flags & FC)) & 0xff))                      \
            flags |= FZ;                                                 \
        else                                                             \
            flags &= ~FZ;                                                \
        if (temp & 0x80)                                                 \
            flags |= FN;                                                 \
        else                                                             \
            flags &= ~FN;                                                \
        if (((a ^ temp) & 0x80) && !((a ^ tempval) & 0x80))              \
            flags |= FV;                                                 \
        else                                                             \
            flags &= ~FV;                                                \
        if ((temp & 0x1f0) > 0x90) temp += 0x60;                         \
        if ((temp & 0xff0) > 0xf0)                                       \
            flags |= FC;                                                 \
        else                                                             \
            flags &= ~FC;                                                \
    }                                                                    \
    else                                                                 \
    {                                                                    \
        temp = tempval + a + (flags & FC);                               \
        SETFLAGS(temp & 0xff);                                           \
        if (!((a ^ tempval) & 0x80) && ((a ^ temp) & 0x80))              \
            flags |= FV;                                                 \
        else                                                             \
            flags &= ~FV;                                                \
        if (temp > 0xff)                                                 \
            flags |= FC;                                                 \
        else                                                             \
            flags &= ~FC;                                                \
    }                                                                    \
    a = temp;                                                            \
}

#define SBC(data)                                                        \
{                                                                        \
    unsigned tempval = data;                                             \
    temp = a - tempval - ((flags & FC) ^ FC);                            \
                                                                         \
    if (flags & FD)                                                      \
    {                                                                    \
        unsigned tempval2;                                               \
        tempval2 = (a & 0xf) - (tempval & 0xf) - ((flags & FC) ^ FC);    \
        if (tempval2 & 0x10)                                             \
            tempval2 = ((tempval2 - 6) & 0xf) | ((a & 0xf0) - (tempval   \
            & 0xf0) - 0x10);                                             \
        else                                                             \
            tempval2 = (tempval2 & 0xf) | ((a & 0xf0) - (tempval         \
            & 0xf0));                                                    \
        if (tempval2 & 0x100)                                            \
            tempval2 -= 0x60;                                            \
        if (temp < 0x100)                                                \
            flags |= FC;                                                 \
        else                                                             \
            flags &= ~FC;                                                \
        SETFLAGS(temp & 0xff);                                           \
        if (((a ^ temp) & 0x80) && ((a ^ tempval) & 0x80))               \
            flags |= FV;                                                 \
        else                                                             \
            flags &= ~FV;                                                \
        a = tempval2;                                                    \
    }                                                                    \
    else                                                                 \
    {                                                                    \
        SETFLAGS(temp & 0xff);                                           \
        if (temp < 0x100)                                                \
            flags |= FC;                                                 \
        else                                                             \
            flags &= ~FC;                                                \
        if (((a ^ temp) & 0x80) && ((a ^ tempval) & 0x80))               \
            flags |= FV;                                                 \
        else                                                             \
            flags &= ~FV;                                                \
        a = temp;                                                        \
    }                                                                    \
}

#define CMP(src, data)                  \
{                                       \
  temp = (src - data) & 0xff;           \
                                        \
  flags = (flags & ~(FC|FN|FZ)) |       \
          (temp & FN);                  \
                                        \
  if (!temp) flags |= FZ;               \
  if (src >= data) flags |= FC;         \
}

#define ASL(data)                       \
{                                       \
  temp = data;                          \
  temp <<= 1;                           \
  if (temp & 0x100) flags |= FC;        \
  else flags &= ~FC;                    \
  ASSIGNSETFLAGS(data, temp);           \
}

#define LSR(data)                       \
{                                       \
  temp = data;                          \
  if (temp & 1) flags |= FC;            \
  else flags &= ~FC;                    \
  temp >>= 1;                           \
  ASSIGNSETFLAGS(data, temp);           \
}

#define ROL(data)                       \
{                                       \
  temp = data;                          \
  temp <<= 1;                           \
  if (flags & FC) temp |= 1;            \
  if (temp & 0x100) flags |= FC;        \
  else flags &= ~FC;                    \
  ASSIGNSETFLAGS(data, temp);           \
}

#define ROR(data)                       \
{                                       \
  temp = data;                          \
  if (flags & FC) temp |= 0x100;        \
  if (temp & 1) flags |= FC;            \
  else flags &= ~FC;                    \
  temp >>= 1;                           \
  ASSIGNSETFLAGS(data, temp);           \
}

#define DEC(data)                       \
{                                       \
  temp = data - 1;                      \
  ASSIGNSETFLAGS(data, temp);           \
}

#define INC(data)                       \
{                                       \
  temp = data + 1;                      \
  ASSIGNSETFLAGS(data, temp);           \
}

#define EOR(data)                       \
{                                       \
  a ^= data;                            \
  SETFLAGS(a);                          \
}

#define ORA(data)                       \
{                                       \
  a |= data;                            \
  SETFLAGS(a);                          \
}

#define AND(data)									\
{													\
	/*if(a==0xF0) printf("AND: %i & %i\n",a,data);*/	\
	a &= data;										\
	/*if(data==0xF0)printf("Result: %i\n",a);*/			\
	SETFLAGS(a)										\
}

#define BIT(data)                       \
{                                       \
  flags = (flags & ~(FN|FV)) |          \
          (data & (FN|FV));             \
  if (!(data & a)) flags |= FZ;         \
  else flags &= ~FZ;                    \
}
