enum{
	ERR,
	IMP,
	IMM,
	ZPG,
	ZPX,
	ZPY,
	ABS,
	ABX,
	ABY,
	REL,
	IDX,
	IDY
};

const char* blargg[]={
	"ERR",
	"IMP",
	"IMM",
	"ZPG",
	"ZPX",
	"ZPY",
	"ABS",
	"ABX",
	"ABY",
	"REL",
	"IDX",
	"IDY"
};

const char* opcodes[]={
	"BRK","ORA","ERR","ERR","ERR","ORA","ASL","ERR","PHP","ORA","ASL","ERR","ERR","ORA","ASL","ERR",
	"BPL","ORA","ERR","ERR","ERR","ORA","ASL","ERR","CLC","ORA","ERR","ERR","ERR","ORA","ASL","ERR",
	"JSR","AND","ERR","ERR","BIT","AND","ERR","ERR","PLP","AND","ROL","ERR","BIT","AND","ROL","ERR",
	"BMI","AND","ERR","ERR","ERR","AND","ERR","ERR","SEC","AND","ERR","ERR","ERR","AND","ROL","ERR",
	"RTI","EOR","ERR","ERR","ERR","EOR","LSR","ERR","PHA","EOR","LSR","ERR","JMP","EOR","LSR","ERR",
	"BVC","EOR","ERR","ERR","ERR","EOR","LSR","ERR","CLI","EOR","ERR","ERR","ERR","EOR","LSR","ERR",
	"RTS","ADC","ERR","ERR","ERR","ADC","ERR","ERR","PLA","ADC","ROR","ERR","ERR","ADC","ROR","ERR",
	"BVS","ADC","ERR","ERR","ERR","ADC","ERR","ERR","SEI","ADC","ERR","ERR","ERR","ADC","ROR","ERR",
	"ERR","STA","ERR","ERR","ERR","STA","ERR","ERR","DEY","ERR","TXA","ERR","STY","STA","STX","ERR",
	"BCC","STA","ERR","ERR","ERR","STA","ERR","ERR","TYA","STA","TXS","ERR","ERR","STA","ERR","ERR",
	"LDY","LDA","LDX","ERR","LDY","LDA","LDX","ERR","TAY","LDA","TAX","ERR","LDY","LDA","LDX","ERR",
	"BCS","LDA","ERR","ERR","LDY","LDA","LDX","ERR","CLV","LDA","TSX","ERR","LDY","LDA","LDX","ERR",
	"CPY","CMP","ERR","ERR","CPY","CMP","DEC","ERR","INY","CMP","DEX","ERR","CPY","CMP","DEC","ERR",
	"BNE","CMP","ERR","ERR","ERR","CMP","DEC","ERR","CLD","CMP","ERR","ERR","ERR","CMP","DEC","ERR",
	"CPX","SBC","ERR","ERR","CPX","SBC","INC","ERR","INX","SBC","NOP","ERR","CPX","SBC","INC","ERR",
	"BEQ","SBC","ERR","ERR","ERR","SBC","INC","ERR","SED","SBC","ERR","ERR","ERR","SBC","INC","ERR",
};

int opmodes[]={
	IMP,IDX,ERR,ERR,ERR,ZPG,ZPG,ERR,IMP,IMM,IMP,ERR,ERR,ABS,ABS,ERR,
	REL,IDY,ERR,ERR,ERR,ZPX,ZPX,ERR,IMP,ABY,ERR,ERR,ERR,ABX,ABX,ERR,
	ABS,IDX,ERR,ERR,ZPG,ZPG,ERR,ERR,IMP,IMM,IMP,ERR,ABS,ABS,ABS,ERR,
	REL,IDY,ERR,ERR,ERR,ZPX,ERR,ERR,IMP,ABY,ERR,ERR,ERR,ABX,ABX,ERR,
	IMP,IDX,ERR,ERR,ERR,ZPG,ZPG,ERR,IMP,IMM,IMP,ERR,ABS,ABS,ABS,ERR,
	REL,IDY,ERR,ERR,ERR,ZPX,ZPX,ERR,IMP,ABY,ERR,ERR,ERR,ABX,ABX,ERR,
	IMP,IDX,ERR,ERR,ERR,ZPG,ERR,ERR,IMP,IMM,IMP,ERR,ERR,ABS,ABS,ERR,
	REL,IDY,ERR,ERR,ERR,ZPX,ERR,ERR,IMP,ABY,ERR,ERR,ERR,ABX,ABX,ERR,
	ERR,IDX,ERR,ERR,ERR,ZPG,ERR,ERR,IMP,ERR,IMP,ERR,ABS,ABS,ABS,ERR,
	REL,IDY,ERR,ERR,ERR,ZPX,ERR,ERR,IMP,ABY,IMP,ERR,ERR,ABX,ERR,ERR,
	IMM,IDX,IMM,ERR,ZPG,ZPG,ZPG,ERR,IMP,IMM,IMP,ERR,ABS,ABS,ABS,ERR,
	REL,IDY,ERR,ERR,ZPX,ZPX,ZPY,ERR,IMP,ABY,IMP,ERR,ABX,ABX,ABY,ERR,
	IMM,IDX,ERR,ERR,ZPG,ZPG,ZPG,ERR,IMP,IMM,IMP,ERR,ABS,ABS,ABS,ERR,
	REL,IDY,ERR,ERR,ERR,ZPX,ZPX,ERR,IMP,ABY,ERR,ERR,ERR,ABX,ABX,ERR,
	IMM,IDX,ERR,ERR,ZPG,ZPG,ZPG,ERR,IMP,IMM,IMP,ERR,ABS,ABS,ABS,ERR,
	REL,IDY,ERR,ERR,ERR,ZPX,ZPX,ERR,IMP,ABY,ERR,ERR,ERR,ABX,ABX,ERR,
};

int opbytes[]={
	1,2,0,0,0,2,2,0,1,2,1,0,0,3,3,0,
	2,2,0,0,0,2,2,0,1,3,0,0,0,3,3,0,
	3,2,0,0,2,2,0,0,1,2,1,0,3,3,3,0,
	2,2,0,0,0,2,0,0,1,3,0,0,0,3,3,0,
	1,2,0,0,0,2,2,0,1,2,1,0,3,3,3,0,
	2,2,0,0,0,2,2,0,1,3,0,0,0,3,3,0,
	1,2,0,0,0,2,0,0,1,2,1,0,0,3,3,0,
	2,2,0,0,0,2,0,0,1,3,0,0,0,3,3,0,
	0,2,0,0,0,2,0,0,1,0,1,0,3,3,3,0,
	2,2,0,0,0,2,0,0,1,3,1,0,0,3,0,0,
	2,2,2,0,2,2,2,0,1,2,1,0,3,3,3,0,
	2,2,0,0,2,2,2,0,1,3,1,0,3,3,3,0,
	2,2,0,0,2,2,2,0,1,2,1,0,3,3,3,0,
	2,2,0,0,0,2,2,0,1,3,0,0,0,3,3,0,
	2,2,0,0,2,2,2,0,1,2,1,0,3,3,3,0,
	2,2,0,0,0,2,2,0,1,3,0,0,0,3,3,0,
};
