#define NOTE_COUNT 96

class CNSF_Emu;
class CFTMFile;

class NSFImporter {
public:
	unsigned char fds_data[64][64];
	unsigned char n163_data[256][16];
	unsigned char n163_pwave[8][16];

	int freqtable[NOTE_COUNT];	// For 2A03/MMC5/VRC6/S5B
	int paltable[NOTE_COUNT];	// For 2A07	
	int sawtable[NOTE_COUNT];	// For VRC6 sawtooth
	int n163table[NOTE_COUNT];	// For N163
	int fdstable[NOTE_COUNT];	// For FDS
	
	int d_bank[96];
	int d_addr[96];
	int d_offset[96];
	int d_length[96];
	
	int p_ftnote[32];
	int p_ftoct[32];
	int p_ftinst[32];
	int p_ftvol[32];
	int p_ftfx1[32];
	int p_ftfx2[32];
	int n163_inst_idx[16];
	int fds_inst_idx[16];
	int vrc7_inst_idx[16];
	
	unsigned char n163_inst[256];
	unsigned char n163_wave[256];
	unsigned char n163_addr[256];
	unsigned char n163_length[256];
	
	unsigned char vrc7_data[64][8];	
	unsigned char vrc7_patch[64];	

	unsigned char n163_paddr[8];
	unsigned char n163_plength[8];
	unsigned char n163_pinst[8];	
	
	CNSF_Emu* pNSF;
	CFTMFile* pFTM;
	
	int n_channels;
	int d_count;
	int vrc6_ch;
	int vrc6_inst;
	int mmc5_ch;
	int s5b_ch;
	int s5b_inst;
	
	int n163_ch;
	int n163_count;
	int n163_instruments;
	
	int fds_ch;
	int fds_count;
	
	int vrc7_ch;
	int vrc7_count;	

	NSFImporter();
	
	bool Import(char* filename, int track, int seconds);
	bool NSF2FTM(int track, int ticks);
	
	void Read_2A03(int first_pattern, int c_row);
	void Read_VRC6(int first_pattern, int c_row);
	void Read_VRC7(int first_pattern, int c_row);
	void Read_MMC5(int first_pattern, int c_row);
	void Read_N163(int first_pattern, int c_row);
	void Read_FDS(int first_pattern, int c_row);
	void Read_S5B(int first_pattern, int c_row);
	
	void GetNote(int Register, int& Note, int& Octave, int& Pitch);
	void GetSawNote(int Register, int& Note, int& Octave, int& Pitch);
	void GetN163Note(int Register, int& Note, int& Octave, int& Pitch);
	void GetFDSNote(int Register, int& Note, int& Octave, int& Pitch);
	void GetVRC7Note(unsigned char RegF, unsigned char RegO, int& Note, int& Octave, int& Pitch);
};

/*
namespace NSFImport
{
	bool Import(char* filename, int track, int seconds);

	void init_tables();

	void Read_2A03(int first_pattern, int c_row);
	void Read_VRC6(int first_pattern, int c_row);
	void Read_VRC7(int first_pattern, int c_row);
	void Read_MMC5(int first_pattern, int c_row);
	void Read_FDS(int first_pattern, int c_row);
	void Read_N163(int first_pattern, int c_row);
	void Read_S5B(int first_pattern, int c_row);
	
	void GetNote(int Register, int& Note, int& Octave, int& Pitch);
	void GetSawNote(int Register, int& Note, int& Octave, int& Pitch);
	void GetN163Note(int Register, int& Note, int& Octave, int& Pitch);
	void GetFDSNote(int Register, int& Note, int& Octave, int& Pitch);
	void GetVRC7Note(unsigned char RegF, unsigned char RegO, int& Note, int& Octave, int& Pitch);
	void GetS5BNote(int Register, int& Note, int& Octave, int& Pitch);
}*/