#include <cstdio>
#include "FTMFile.h"

struct NSF_Event {
	byte apu_regs[0x18];
};


class CNSF_Emu {
public: CNSF_Emu();

	FILE* fp_src;
	FILE* fp_dst;
	FILE* fp_log;

	CFTMFile* pFTM;
	NSF_Event* Event;

	int src_size;
	int n_banks;
	int c_bank[8];

	unsigned char* data;
	unsigned char* bdata;
	int* op_count;

	struct stInfo{
		char file_id[5];
		unsigned char version;
		unsigned char n_songs;
		unsigned char first;
		unsigned short load_addr;
		unsigned short init_addr;
		unsigned short play_addr;
		char title[32];
		char author[32];
		char ccccc[32];
		unsigned short ntsc_speed;
		unsigned char banks_init[8];
		unsigned short pal_speed;
		unsigned char machine;
		unsigned char expansion;
		char reserved[4];
	} Info;

	struct stRegs_N163{
		int freq;
		int w_length;
		int w_addr;
		int vol;
	} N163[8];

	unsigned char vrc7_regs[8][4];

	unsigned char n163_wram[64];

	unsigned char s5b_regs[16];

	unsigned char vrc7_custom[8];

	int vrc6_freq[3];
	unsigned char vrc6_vol[4];

	bool is_switched;
	bool is_FDS;

	unsigned short pc;
	unsigned char a;
	unsigned char x;
	unsigned char y;
	unsigned char flags;
	unsigned char sp;

	char dpcm_triggered;

	unsigned char vrc7_addr;
	unsigned char n163_addr;
	unsigned char s5b_addr;
	unsigned char n163_ch;

	bool LoadFile(char* filename);
	bool ReadHeader();
	bool ReadData();

	bool LogHeader();
	bool LogData();

	bool LogDisasm();

	bool Init(int track);
	bool PlayOnce();
	int RunCpu();
};

